import { api } from "zen-cerebellum";

import { getCurrentUserId } from "../utils";
import { USER_AUTH_PWD } from "../constants";

export function encodePassword(password) {
  //simple base 64 encoding
  return window.btoa(password);
}

//RAA : user password change
export const resetUserPassword = api.make(
  api.patch,
  USER_AUTH_PWD,
  (_, s) => `/users/${getCurrentUserId(s)}/`,
  pwd => ({ Password: encodePassword(pwd) })
);

//WAA : reset password request
export function requestNewPassword(instance, login) {
  return api.post(USER_AUTH_PWD, "/auth/resetpasswordrequest", {
    Login: login,
    Instance: instance
  });
}

//WAA : reset password acknowledgment
export function commitNewPassword(ack) {
  return api.post(USER_AUTH_PWD, "/auth/resetpasswordack", ack);
}
